<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>sdioemb: sdio_slot struct Reference</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.3.5 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="pages.html">Related&nbsp;Pages</a></div>
<h1>sdio_slot Struct Reference<br>
<small>
[<a class="el" href="group__sdriver.html">SDIO slot driver API</a>]</small>
</h1><code>#include &lt;<a class="el" href="slot__api_8h-source.html">slot_api.h</a>&gt;</code>
<p>
<table border=0 cellpadding=0 cellspacing=0>
<tr><td></td></tr>
<tr><td colspan=2><br><h2>Data Fields</h2></td></tr>
<tr><td class="memItemLeft" nowrap align=right valign=top>char&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o0">name</a> [64]</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>enum slot_controller_type&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o1">type</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o2">set_bus_freq</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, int clk)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o3">set_bus_width</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, int <a class="el" href="structsdio__slot.html#o12">bus_width</a>)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o4">start_cmd</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, struct <a class="el" href="structsdio__cmd.html">sdio_cmd</a> *cmd)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o5">card_present</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o6">card_power</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, enum <a class="el" href="group__sdriver.html#ga32">sdio_power</a> power)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o7">enable_card_int</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o8">disable_card_int</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int(*&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o9">hard_reset</a> )(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)</td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top><a class="el" href="structslot__caps.html">slot_caps</a>&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o10">caps</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o11">clock_freq</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o12">bus_width</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o13">cspi_reg_pad</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>int&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o14">cspi_burst_pad</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>sdio_slot_priv *&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o15">priv</a></td></tr>

<tr><td class="memItemLeft" nowrap align=right valign=top>void *&nbsp;</td><td class="memItemRight" valign=bottom><a class="el" href="structsdio__slot.html#o16">drv_data</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
An SDIO slot driver.<p>
Allocate and free with <a class="el" href="group__sdriver.html#ga8">sdio_slot_alloc()</a> and <a class="el" href="group__sdriver.html#ga9">sdio_slot_free()</a>. 
<p>
<hr><h2>Field Documentation</h2>
<a class="anchor" name="o12" doxytag="sdio_slot::bus_width" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int <a class="el" href="structsdio__slot.html#o12">sdio_slot::bus_width</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Bus width requested by the SDIO layer.     </td>
  </tr>
</table>
<a class="anchor" name="o10" doxytag="sdio_slot::caps" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> struct <a class="el" href="structslot__caps.html">slot_caps</a> <a class="el" href="structsdio__slot.html#o10">sdio_slot::caps</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Slot capabilities.     </td>
  </tr>
</table>
<a class="anchor" name="o6" doxytag="sdio_slot::card_power" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o6">sdio_slot::card_power</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, enum <a class="el" href="group__sdriver.html#ga32">sdio_power</a> power)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Switch on/off the SDIO bus power and set the SDIO bus voltage.<p>
Called from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot. </td></tr>
    <tr><td valign=top><em>power</em>&nbsp;</td><td>the requested voltage.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success; -ve on error: -EINVAL - requested voltage is not supported. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o5" doxytag="sdio_slot::card_present" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o5">sdio_slot::card_present</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Detect if a card is inserted into the slot.<p>
Called from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>slot to check.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>non-zero if a card is inserted; 0 otherwise. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o11" doxytag="sdio_slot::clock_freq" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int <a class="el" href="structsdio__slot.html#o11">sdio_slot::clock_freq</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
SD bus frequency requested by the SDIO layer.     </td>
  </tr>
</table>
<a class="anchor" name="o14" doxytag="sdio_slot::cspi_burst_pad" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int <a class="el" href="structsdio__slot.html#o14">sdio_slot::cspi_burst_pad</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Padding for CSPI burst reads.     </td>
  </tr>
</table>
<a class="anchor" name="o13" doxytag="sdio_slot::cspi_reg_pad" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int <a class="el" href="structsdio__slot.html#o13">sdio_slot::cspi_reg_pad</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Padding for CSPI register reads.     </td>
  </tr>
</table>
<a class="anchor" name="o8" doxytag="sdio_slot::disable_card_int" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__slot.html#o8">sdio_slot::disable_card_int</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Disable (mask) the SDIO card interrupt on the controller.<p>
Called from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot to disable the interrupt on. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o16" doxytag="sdio_slot::drv_data" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void* <a class="el" href="structsdio__slot.html#o16">sdio_slot::drv_data</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Data private to the slot driver.     </td>
  </tr>
</table>
<a class="anchor" name="o7" doxytag="sdio_slot::enable_card_int" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> void(* <a class="el" href="structsdio__slot.html#o7">sdio_slot::enable_card_int</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Enable (unmask) the SDIO card interrupt on the controller.<p>
Called from: interrupt context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot to enable the interrupt on.. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o9" doxytag="sdio_slot::hard_reset" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o9">sdio_slot::hard_reset</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Perform a hard reset of the card.<p>
Hard resets can be achieved in two ways:<p>
<ol>
<li>Power cycle (if the slot has power control).</li><li>Platform-specific assertion of a card/chip reset line.</li></ol>
<p>
If hard resets are not supported, either return 0 or set hard_reset to NULL.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot for the card to reset.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 if a hard reset was performed. <p>
1 if hard resets are not supported. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o0" doxytag="sdio_slot::name" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> char <a class="el" href="structsdio__slot.html#o0">sdio_slot::name</a>[64]
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Name of the slot used in diagnostic messages.<p>
This would typically include the name of the SDIO controller and the slot number if the controller has multiple slots.     </td>
  </tr>
</table>
<a class="anchor" name="o15" doxytag="sdio_slot::priv" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> struct sdio_slot_priv* <a class="el" href="structsdio__slot.html#o15">sdio_slot::priv</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Data private to the SDIO layer.     </td>
  </tr>
</table>
<a class="anchor" name="o2" doxytag="sdio_slot::set_bus_freq" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o2">sdio_slot::set_bus_freq</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, int clk)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set the SD bus clock frequency.<p>
The driver's implementation should set the SD bus clock to not more than <em>clk</em> Hz (unless <em>clk</em> is equal to #SDD_BUS_FREQ_OFF or #SDD_BUS_FREQ_IDLE).<p>
If <em>clk</em> == SDD_BUS_FREQ_OFF the clock should be stopped.<p>
<em>clk</em> == SDD_BUS_FREQ_IDLE indicates that the bus is idle (currently unused) and the host controller may slow (or stop) the SD bus clock to save power on the card. During this idle state the host controller must be capable of receiving SDIO interrupts (for certain host controllers this may require leaving the clock running).<p>
If <em>clk</em> is greater than #SDIO_CLOCK_FREQ_NORMAL_SPD (25 MHz) subsequent commands should be done with the controller in high speed mode.<p>
Called from: interrupt context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot to configure. </td></tr>
    <tr><td valign=top><em>clk</em>&nbsp;</td><td>new SD bus clock frequency in Hz, SDD_BUS_FREQ_OFF or SDD_BUS_FREQ_IDLE.</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>The bus frequency actually configured in Hz. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o3" doxytag="sdio_slot::set_bus_width" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o3">sdio_slot::set_bus_width</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, int <a class="el" href="structsdio__slot.html#o12">bus_width</a>)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Set the SD bus width.<p>
The driver's implementation should set the width of the SD bus for all subsequent data transfers to the specified value.<p>
This may be NULL if the driver sets the bus width when starting a command, or the driver is for an SDIO-SPI or CSPI controller.<p>
Called from: thread context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>the slot to configure. </td></tr>
    <tr><td valign=top><em>bus_width</em>&nbsp;</td><td>new SD bus width (either 1 or 4).</td></tr>
  </table>
</dl>
<dl compact><dt><b>Returns:</b></dt><dd>0 on success. <p>
-ve if a low-level error occured when setting the bus width. </dd></dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o4" doxytag="sdio_slot::start_cmd" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> int(* <a class="el" href="structsdio__slot.html#o4">sdio_slot::start_cmd</a>)(struct <a class="el" href="structsdio__slot.html">sdio_slot</a> *slot, struct <a class="el" href="structsdio__cmd.html">sdio_cmd</a> *cmd)
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Start an SDIO command.<p>
The driver's implementation should:<p>
<ul>
<li>set the controller's bus width to <a class="el" href="structsdio__slot.html#o12">bus_width</a>,</li><li>program the controller to start the command.</li></ul>
<p>
Called from: interrupt context.<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign=top><em>slot</em>&nbsp;</td><td>slot to perform the command. </td></tr>
    <tr><td valign=top><em>cmd</em>&nbsp;</td><td>SDIO command to start. </td></tr>
  </table>
</dl>
    </td>
  </tr>
</table>
<a class="anchor" name="o1" doxytag="sdio_slot::type" ></a><p>
<table class="mdTable" width="100%" cellpadding="2" cellspacing="0">
  <tr>
    <td class="mdRow">
      <table cellpadding="0" cellspacing="0" border="0">
        <tr>
          <td class="md" nowrap valign="top"> enum slot_controller_type <a class="el" href="structsdio__slot.html#o1">sdio_slot::type</a>
      </table>
    </td>
  </tr>
</table>
<table cellspacing=5 cellpadding=0 border=0>
  <tr>
    <td>
      &nbsp;
    </td>
    <td>

<p>
Controller hardware type.     </td>
  </tr>
</table>
<hr>The documentation for this struct was generated from the following file:<ul>
<li>/home/bfsw/host/releases/sdioemb/sdioemb-15/builds/sdioemb-15/include/sdioemb/<a class="el" href="slot__api_8h-source.html">slot_api.h</a></ul>
<hr size="1"><address style="align: right;"><small>Generated on Fri Nov 21 14:14:54 2008 for sdioemb by
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border=0 > 
</a>1.3.5 </small></address>
</body>
</html>
